#!/usr/bin/env python

##SLICE 3
"""
slicefilter extracts slices from specially-prepared input.
"""
##SLICE 1
import sys
##SLICE 2
"You are looking at level two! This is exciting!"
##SLICE 1

import getopt

try:
    opts, rargs= getopt.getopt(sys.argv[1:], 'o:m:')
except:
    print "syntax: slicefilter [-o outputfile] [-m mask] inputfile"
    sys.exit(1)

try:
    if rargs:
        infile=open(rargs[0],"rt")
    else:
        infile=sys.stdin
except Exception, e:
    print "cannot open",rargs[0]
    print str(e)
    sys.exit(2)

mask=1
try:
    for o,a in opts:
        if o=='-o':
            outfile=open(a,"w+t")
            break
        if o=='-m':
            mask = int(a)
    else:
        outfile=sys.stdout
except Exception, e:
    print str(e)
    sys.exit(2)

commentDelim = None
visible = 1&mask

for aLine in infile.readlines():
    if commentDelim is None:
        if len(aLine) >= 3:
            if aLine[1] == '!':
                commentDelim="%c%cSLICE"%(aLine[0],aLine[0])
            else:
                commentDelim=aLine[:2]+"SLICE"
        if visible: print >>outfile, aLine,
    else:
        if aLine[:7]==commentDelim:
            sliceCtx=int(aLine[7:])
            visible = sliceCtx&mask
        else:
            if visible: print >>outfile, aLine,
        
##SLICE 2
"Boo!"
